Index: trunk/LMDZ.GENERIC/libf/phystd/totalcloudfrac.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/totalcloudfrac.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/totalcloudfrac.F90	(revision 1308)
@@ -1,3 +1,3 @@
-      subroutine totalcloudfrac(ngrid,nq,rneb,totalrneb,pplev,pq,tau)
+      subroutine totalcloudfrac(ngrid,nlayer,nq,rneb,totalrneb,pplev,pq,tau)
 
       use watercommon_h
@@ -19,18 +19,19 @@
 !==================================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
 
       integer,intent(in) :: ngrid        ! number of atmospheric columns
+      integer,intent(in) :: nlayer       ! number of atmospheric layers
       integer,intent(in) :: nq           ! number of tracers
-      real,intent(in) :: rneb(ngrid,nlayermx)    ! cloud fraction     
+      real,intent(in) :: rneb(ngrid,nlayer)    ! cloud fraction     
       real,intent(out) :: totalrneb(ngrid)       ! total cloud fraction 
-      real,intent(in) :: pplev(ngrid,nlayermx+1) ! inter-layer pressure (Pa)
-      real,intent(in) :: pq(ngrid,nlayermx,nq)   ! tracers (.../kg_of_air)
-      real,intent(in) :: tau(ngrid,nlayermx)
+      real,intent(in) :: pplev(ngrid,nlayer+1) ! inter-layer pressure (Pa)
+      real,intent(in) :: pq(ngrid,nlayer,nq)   ! tracers (.../kg_of_air)
+      real,intent(in) :: tau(ngrid,nlayer)
 
-      real, dimension(nlayermx+1) :: masse
+      real, dimension(nlayer+1) :: masse
       integer, parameter          :: recovery=7
       integer ltau_max
@@ -47,5 +48,5 @@
       real clear,tau_min
       real, parameter ::  tau_c=0.1 !threshold of optical depth for the calculation of total cloud fraction 
-      real rneb2(nlayermx)
+      real rneb2(nlayer)
 
 
@@ -55,5 +56,5 @@
          if (recovery.eq.1) then
             clear = (1.-rneb(ig,1))
-            do l=2,nlayermx       
+            do l=2,nlayer      
                clear = clear*(1.-rneb(ig,l))
             enddo
@@ -62,5 +63,5 @@
          elseif (recovery.eq.2) then
             totalrneb(ig) = rneb(ig,1)
-            do l=2,14 !nlayermx       
+            do l=2,14 !nlayer    
                totalrneb(ig) = max(rneb(ig,l),totalrneb(ig))
             enddo
@@ -68,5 +69,5 @@
          elseif (recovery.eq.3) then
             totalrneb(ig) = rneb(ig,1)
-            do l=2,nlayermx       
+            do l=2,nlayer    
                totalrneb(ig) = min(rneb(ig,l),totalrneb(ig))
             enddo
@@ -77,5 +78,5 @@
          elseif (recovery.eq.5) then
             totalrneb(ig) = rneb(ig,1)            
-            do l=1,nlayermx
+            do l=1,nlayer
                masse(l)=pq(ig,l,igcm_h2o_ice)*(pplev(ig,l)-pplev(ig,l+1))
             enddo
@@ -85,10 +86,10 @@
          elseif (recovery.eq.6) then
             totalrneb(ig) = 0.            
-            do l=1,nlayermx
+            do l=1,nlayer
                masse(l)=pq(ig,l,igcm_h2o_ice)*(pplev(ig,l)-pplev(ig,l+1))
                masse(l)=max(masse(l),0.)
             enddo
             massetot=sum(masse,dim=1)
-            do l=1,nlayermx
+            do l=1,nlayer
                totalrneb(ig) = totalrneb(ig)+rneb(ig,l)*masse(l)/massetot
             enddo
@@ -96,10 +97,10 @@
          elseif (recovery.eq.7) then
 
-            rneb2(:)=rneb(ig,1:nlayermx)
-	    tau_min=MIN(tau_c,MAXVAL(tau(ig,1:nlayermx))/2.)
-            do l=1,nlayermx
+            rneb2(:)=rneb(ig,1:nlayer)
+	    tau_min=MIN(tau_c,MAXVAL(tau(ig,1:nlayer))/2.)
+            do l=1,nlayer
                if(tau(ig,l)<tau_min) rneb2(l)=0.      	
             enddo
-            totalrneb(ig)=maxval(rneb2(1:nlayermx))
+            totalrneb(ig)=maxval(rneb2(1:nlayer))
 
          endif                  ! (recovery=)   
Index: trunk/LMDZ.GENERIC/libf/phystd/turbdiff.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/turbdiff.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/turbdiff.F90	(revision 1308)
@@ -41,6 +41,6 @@
 !     ------------
 
-      include "dimensions.h"
-      include "dimphys.h"
+!      include "dimensions.h"
+!      include "dimphys.h"
       include "comcstfi.h"
       include "callkeys.h"
@@ -48,5 +48,6 @@
 !     arguments
 !     ---------
-      INTEGER,INTENT(IN) :: ngrid,nlay
+      INTEGER,INTENT(IN) :: ngrid
+      INTEGER,INTENT(IN) :: nlay
       REAL,INTENT(IN) :: ptimestep
       REAL,INTENT(IN) :: pplay(ngrid,nlay),pplev(ngrid,nlay+1)
@@ -86,18 +87,18 @@
 
       REAL z4st,zdplanck(ngrid)
-      REAL zkv(ngrid,nlayermx+1),zkh(ngrid,nlayermx+1)
+      REAL zkv(ngrid,nlay+1),zkh(ngrid,nlay+1)
       REAL zcdv(ngrid),zcdh(ngrid)
       REAL zcdv_true(ngrid),zcdh_true(ngrid)
-      REAL zu(ngrid,nlayermx),zv(ngrid,nlayermx)
-      REAL zh(ngrid,nlayermx),zt(ngrid,nlayermx)
+      REAL zu(ngrid,nlay),zv(ngrid,nlay)
+      REAL zh(ngrid,nlay),zt(ngrid,nlay)
       REAL ztsrf(ngrid)
       REAL z1(ngrid),z2(ngrid)
-      REAL zmass(ngrid,nlayermx)
-      REAL zfluxv(ngrid,nlayermx),zfluxt(ngrid,nlayermx),zfluxq(ngrid,nlayermx)
-      REAL zb0(ngrid,nlayermx)
-      REAL zExner(ngrid,nlayermx),zovExner(ngrid,nlayermx)
-      REAL zcv(ngrid,nlayermx),zdv(ngrid,nlayermx)  !inversion coefficient for winds
-      REAL zct(ngrid,nlayermx),zdt(ngrid,nlayermx)  !inversion coefficient for temperature
-      REAL zcq(ngrid,nlayermx),zdq(ngrid,nlayermx)  !inversion coefficient for tracers
+      REAL zmass(ngrid,nlay)
+      REAL zfluxv(ngrid,nlay),zfluxt(ngrid,nlay),zfluxq(ngrid,nlay)
+      REAL zb0(ngrid,nlay)
+      REAL zExner(ngrid,nlay),zovExner(ngrid,nlay)
+      REAL zcv(ngrid,nlay),zdv(ngrid,nlay)  !inversion coefficient for winds
+      REAL zct(ngrid,nlay),zdt(ngrid,nlay)  !inversion coefficient for temperature
+      REAL zcq(ngrid,nlay),zdq(ngrid,nlay)  !inversion coefficient for tracers
       REAL zcst1
       REAL zu2!, a
@@ -110,7 +111,7 @@
 !     -------
       INTEGER iq
-      REAL zq(ngrid,nlayermx,nq)
-      REAL zqnoevap(ngrid,nlayermx) !special for water case to compute where evaporated water goes.
-      REAL pdqevap(ngrid,nlayermx) !special for water case to compute where evaporated water goes.
+      REAL zq(ngrid,nlay,nq)
+      REAL zqnoevap(ngrid,nlay) !special for water case to compute where evaporated water goes.
+      REAL pdqevap(ngrid,nlay) !special for water case to compute where evaporated water goes.
       REAL zdmassevap(ngrid)
       REAL rho(ngrid)         ! near-surface air density
@@ -241,5 +242,5 @@
 !     ------------------------------------------------------ 
 
-      call vdif_kc(ngrid,ptimestep,g,pzlev,pzlay,pu,pv,zh,zcdv_true,pq2,zkv,zkh) !JL12 why not call vdif_kc with updated winds and temperature 
+      call vdif_kc(ngrid,nlay,ptimestep,g,pzlev,pzlay,pu,pv,zh,zcdv_true,pq2,zkv,zkh) !JL12 why not call vdif_kc with updated winds and temperature 
       
 !     Adding eddy mixing to mimic 3D general circulation in 1D
@@ -262,5 +263,5 @@
  
 !JL12 calculate the flux coefficients (tables multiplied elements by elements)
-      zfluxv(1:ngrid,1:nlayermx)=zkv(1:ngrid,1:nlayermx)*zb0(1:ngrid,1:nlayermx)
+      zfluxv(1:ngrid,1:nlay)=zkv(1:ngrid,1:nlay)*zb0(1:ngrid,1:nlay)
       
 !-----------------------------------------------------------------------
@@ -364,6 +365,6 @@
 !     JL12 calculate the flux coefficients (tables multiplied elements by elements)
 !     ---------------------------------------------------------------
-      zfluxq(1:ngrid,1:nlayermx)=zkh(1:ngrid,1:nlayermx)*zb0(1:ngrid,1:nlayermx) !JL12 we save zfluxq which doesn't need the Exner factor
-      zfluxt(1:ngrid,1:nlayermx)=zfluxq(1:ngrid,1:nlayermx)*zExner(1:ngrid,1:nlayermx)
+      zfluxq(1:ngrid,1:nlay)=zkh(1:ngrid,1:nlay)*zb0(1:ngrid,1:nlay) !JL12 we save zfluxq which doesn't need the Exner factor
+      zfluxt(1:ngrid,1:nlay)=zfluxq(1:ngrid,1:nlay)*zExner(1:ngrid,1:nlay)
 
       DO ig=1,ngrid
Index: trunk/LMDZ.GENERIC/libf/phystd/vdif_kc.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/vdif_kc.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/vdif_kc.F	(revision 1308)
@@ -1,7 +1,7 @@
-      SUBROUTINE vdif_kc(ngrid,dt,g,zlev,zlay,u,v,teta,cd,q2,km,kn)
+      SUBROUTINE vdif_kc(ngrid,nlay,dt,g,zlev,zlay,u,v,teta,cd,q2,km,kn)
       IMPLICIT NONE
 c.......................................................................
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 c.......................................................................
 c
@@ -28,14 +28,15 @@
 c.......................................................................
       INTEGER,INTENT(IN) :: ngrid
+      INTEGER,INTENT(IN) :: nlay
       REAL,INTENT(IN) :: dt,g
-      REAL,INTENT(IN) :: zlev(ngrid,nlayermx+1)
-      REAL,INTENT(IN) :: zlay(ngrid,nlayermx)
-      REAL,INTENT(IN) :: u(ngrid,nlayermx)
-      REAL,INTENT(IN) :: v(ngrid,nlayermx)
-      REAL,INTENT(IN) :: teta(ngrid,nlayermx)
+      REAL,INTENT(IN) :: zlev(ngrid,nlay+1)
+      REAL,INTENT(IN) :: zlay(ngrid,nlay)
+      REAL,INTENT(IN) :: u(ngrid,nlay)
+      REAL,INTENT(IN) :: v(ngrid,nlay)
+      REAL,INTENT(IN) :: teta(ngrid,nlay)
       REAL,INTENT(IN) :: cd(ngrid)
-      REAL,INTENT(INOUT) :: q2(ngrid,nlayermx+1)
-      REAL,INTENT(OUT) :: km(ngrid,nlayermx+1)
-      REAL,INTENT(OUT) :: kn(ngrid,nlayermx+1)
+      REAL,INTENT(INOUT) :: q2(ngrid,nlay+1)
+      REAL,INTENT(OUT) :: km(ngrid,nlay+1)
+      REAL,INTENT(OUT) :: kn(ngrid,nlay+1)
 c.......................................................................
 c
@@ -50,9 +51,8 @@
 c
 c.......................................................................
-      INTEGER,PARAMETER :: nlay=nlayermx
-      INTEGER,PARAMETER :: nlev=nlayermx+1
-      REAL unsdz(ngrid,nlayermx)
-      REAL unsdzdec(ngrid,nlayermx+1)
-      REAL q(ngrid,nlayermx+1)
+      INTEGER :: nlev
+      REAL unsdz(ngrid,nlay)
+      REAL unsdzdec(ngrid,nlay+1)
+      REAL q(ngrid,nlay+1)
 c.......................................................................
 c
@@ -64,5 +64,5 @@
 c
 c.......................................................................
-      REAL kmpre(ngrid,nlayermx+1)
+      REAL kmpre(ngrid,nlay+1)
       REAL qcstat
       REAL q2cstat
@@ -72,5 +72,5 @@
 c
 c.......................................................................
-      REAL long(ngrid,nlayermx+1)
+      REAL long(ngrid,nlay+1)
 c.......................................................................
 c
@@ -95,8 +95,8 @@
       REAL mcstat
       REAL m2cstat
-      REAL m(ngrid,nlayermx+1)
-      REAL mpre(ngrid,nlayermx+1)
-      REAL m2(ngrid,nlayermx+1)
-      REAL n2(ngrid,nlayermx+1)
+      REAL m(ngrid,nlay+1)
+      REAL mpre(ngrid,nlay+1)
+      REAL m2(ngrid,nlay+1)
+      REAL n2(ngrid,nlay+1)
 c.......................................................................
 c
@@ -120,9 +120,9 @@
       LOGICAL gnsup
       REAL gm
-c      REAL ri(ngrid,nlayermx+1)
-      REAL sn(ngrid,nlayermx+1)
-      REAL snq2(ngrid,nlayermx+1)
-      REAL sm(ngrid,nlayermx+1)
-      REAL smq2(ngrid,nlayermx+1)
+c      REAL ri(ngrid,nlaye+1)
+      REAL sn(ngrid,nlay+1)
+      REAL snq2(ngrid,nlay+1)
+      REAL sm(ngrid,nlay+1)
+      REAL smq2(ngrid,nlay+1)
 c.......................................................................
 c
@@ -179,4 +179,5 @@
 
 ! initialization of local variables:
+      nlev=nlay+1
       long(:,:)=0.
       n2(:,:)=0.
Index: trunk/LMDZ.GENERIC/libf/phystd/vdifc.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/vdifc.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/vdifc.F	(revision 1308)
@@ -38,6 +38,6 @@
 !     ------------
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
@@ -77,17 +77,17 @@
 
       REAL z4st,zdplanck(ngrid)
-      REAL zkv(ngrid,nlayermx+1),zkh(ngrid,nlayermx+1)
+      REAL zkv(ngrid,nlay+1),zkh(ngrid,nlay+1)
       REAL zcdv(ngrid),zcdh(ngrid)
       REAL zcdv_true(ngrid),zcdh_true(ngrid)
-      REAL zu(ngrid,nlayermx),zv(ngrid,nlayermx)
-      REAL zh(ngrid,nlayermx)
+      REAL zu(ngrid,nlay),zv(ngrid,nlay)
+      REAL zh(ngrid,nlay)
       REAL ztsrf2(ngrid)
       REAL z1(ngrid),z2(ngrid)
-      REAL za(ngrid,nlayermx),zb(ngrid,nlayermx)
-      REAL zb0(ngrid,nlayermx)
-      REAL zc(ngrid,nlayermx),zd(ngrid,nlayermx)
+      REAL za(ngrid,nlay),zb(ngrid,nlay)
+      REAL zb0(ngrid,nlay)
+      REAL zc(ngrid,nlay),zd(ngrid,nlay)
       REAL zcst1
       REAL zu2!, a
-      REAL zcq(ngrid,nlayermx),zdq(ngrid,nlayermx)
+      REAL zcq(ngrid,nlay),zdq(ngrid,nlay)
       REAL evap(ngrid)
       REAL zcq0(ngrid),zdq0(ngrid)
@@ -101,5 +101,5 @@
 !     variables added for CO2 condensation
 !     ------------------------------------
-      REAL hh                   !, zhcond(ngrid,nlayermx)
+      REAL hh                   !, zhcond(ngrid,nlay)
 !     REAL latcond,tcond1mb
 !     REAL acond,bcond
@@ -110,5 +110,5 @@
 !     -------
       INTEGER iq
-      REAL zq(ngrid,nlayermx,nq)
+      REAL zq(ngrid,nlay,nq)
       REAL zq1temp(ngrid)
       REAL rho(ngrid)         ! near-surface air density
@@ -123,6 +123,6 @@
       real z1_T(ngrid), z2_T(ngrid)
       real zb_T(ngrid)
-      real zc_T(ngrid,nlayermx)
-      real zd_T(ngrid,nlayermx)
+      real zc_T(ngrid,nlay)
+      real zd_T(ngrid,nlay)
       real lat1(ngrid), lat2(ngrid)
       real surfh2otot
@@ -249,5 +249,5 @@
 !     ------------------------------------------------------ 
 
-      call vdif_kc(ngrid,ptimestep,g,pzlev,pzlay
+      call vdif_kc(ngrid,nlay,ptimestep,g,pzlev,pzlay
      &     ,pu,pv,ph,zcdv_true
      &     ,pq2,zkv,zkh)
Index: trunk/LMDZ.GENERIC/libf/phystd/vlz_fi.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/vlz_fi.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/vlz_fi.F	(revision 1308)
@@ -1,3 +1,3 @@
-      SUBROUTINE vlz_fi(ngrid,q,pente_max,masse,w,wq)
+      SUBROUTINE vlz_fi(ngrid,nlayer,q,pente_max,masse,w,wq)
 c
 c     Auteurs:   P.Le Van, F.Hourdin, F.Forget 
@@ -16,6 +16,6 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 
 c
@@ -23,9 +23,9 @@
 c   Arguments:
 c   ----------
-      integer ngrid
-      real masse(ngrid,llm),pente_max
-      REAL q(ngrid,llm)
-      REAL w(ngrid,llm)
-      REAL wq(ngrid,llm+1)
+      integer,intent(in) :: ngrid, nlayer
+      real,intent(in) :: masse(ngrid,nlayer),pente_max
+      REAL,INTENT(INOUT) :: q(ngrid,nlayer)
+      REAL,INTENT(INOUT) :: w(ngrid,nlayer)
+      REAL,INTENT(OUT) :: wq(ngrid,nlayer+1)
 c
 c      Local 
@@ -35,5 +35,6 @@
 c
 
-      real dzq(ngrid,llm),dzqw(ngrid,llm),adzqw(ngrid,llm),dzqmax
+      real dzq(ngrid,nlayer),dzqw(ngrid,nlayer),adzqw(ngrid,nlayer)
+      real dzqmax
       real newmasse
       real sigw, Mtot, MQtot
@@ -47,5 +48,5 @@
 c    sens de W
 
-      do l=2,llm
+      do l=2,nlayer
          do ij=1,ngrid
             dzqw(ij,l)=q(ij,l-1)-q(ij,l)
@@ -54,5 +55,5 @@
       enddo
 
-      do l=2,llm-1
+      do l=2,nlayer-1
          do ij=1,ngrid
 #ifdef CRAY
@@ -73,5 +74,5 @@
       do ij=1,ngrid
          dzq(ij,1)=0.
-         dzq(ij,llm)=0.
+         dzq(ij,nlayer)=0.
       enddo
 c ---------------------------------------------------------------
@@ -83,5 +84,5 @@
 c      No flux at the model top:
        do ij=1,ngrid
-          wq(ij,llm+1)=0.
+          wq(ij,nlayer+1)=0.
        enddo
 
@@ -89,5 +90,5 @@
 c      ===============================
 
-       do l = 1,llm          ! loop different than when w<0
+       do l = 1,nlayer          ! loop different than when w<0
         do ij=1,ngrid
 
@@ -107,13 +108,13 @@
             Mtot = masse(ij,m)
             MQtot = masse(ij,m)*q(ij,m)
-            if(m.ge.llm)goto 88
+            if(m.ge.nlayer)goto 88
             do while(w(ij,l).gt.(Mtot+masse(ij,m+1)))
                 m=m+1
                 Mtot = Mtot + masse(ij,m)
                 MQtot = MQtot + masse(ij,m)*q(ij,m)
-                if(m.ge.llm)goto 88
+                if(m.ge.nlayer)goto 88
             end do
  88         continue
-            if (m.lt.llm) then
+            if (m.lt.nlayer) then
                 sigw=(w(ij,l)-Mtot)/masse(ij,m+1)
                 wq(ij,l)=(MQtot + (w(ij,l)-Mtot)*
@@ -137,5 +138,5 @@
        end do
 
-       do l = 1,llm-1  ! loop different than when w>0
+       do l = 1,nlayer-1  ! loop different than when w>0
         do ij=1,ngrid
          if(w(ij,l+1).le.0)then
@@ -176,5 +177,5 @@
  99    continue
 
-      do l=1,llm
+      do l=1,nlayer
          do ij=1,ngrid
 
@@ -191,5 +192,3 @@
 
 
-
-      return
       end
Index: trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F	(revision 1308)
@@ -54,5 +54,5 @@
 ! Commons
 #include "dimensions.h"
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "paramet.h"
 !#include "control.h"
Index: trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F	(revision 1308)
@@ -54,5 +54,5 @@
 ! Commons
 #include "dimensions.h"
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "paramet.h"
 !#include "control.h"
Index: trunk/LMDZ.GENERIC/libf/phystd/wstats.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/wstats.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/wstats.F90	(revision 1308)
@@ -7,5 +7,5 @@
 
 #include "dimensions.h"
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "comconst.h"
 #include "statto.h"
@@ -293,5 +293,5 @@
 
 include "dimensions.h"
-include "dimphys.h"
+!include "dimphys.h"
 include "netcdf.inc"
 
